## EDBusAddressBook EDBusAddressBook |

## Functions

gboolean | e_dbus_address_book_get_online ()
void | e_dbus_address_book_set_online ()
const gchar * | e_dbus_address_book_get_revision ()
gchar * | e_dbus_address_book_dup_revision ()
void | e_dbus_address_book_set_revision ()
const gchar * | e_dbus_address_book_get_locale ()
gchar * | e_dbus_address_book_dup_locale ()
void | e_dbus_address_book_set_locale ()
gboolean | e_dbus_address_book_get_writable ()
void | e_dbus_address_book_set_writable ()
const gchar * | e_dbus_address_book_get_cache_dir ()
gchar * | e_dbus_address_book_dup_cache_dir ()
void | e_dbus_address_book_set_cache_dir ()
const gchar *const * | e_dbus_address_book_get_capabilities ()
gchar ** | e_dbus_address_book_dup_capabilities ()
void | e_dbus_address_book_set_capabilities ()
const gchar *const * | e_dbus_address_book_get_required_fields ()
gchar ** | e_dbus_address_book_dup_required_fields ()
void | e_dbus_address_book_set_required_fields ()
const gchar *const * | e_dbus_address_book_get_supported_fields ()
gchar ** | e_dbus_address_book_dup_supported_fields ()
void | e_dbus_address_book_set_supported_fields ()
gboolean | e_dbus_address_book_call_open_sync ()
void | e_dbus_address_book_call_open ()
gboolean | e_dbus_address_book_call_open_finish ()
void | e_dbus_address_book_complete_open ()
gboolean | e_dbus_address_book_call_close_sync ()
void | e_dbus_address_book_call_close ()
gboolean | e_dbus_address_book_call_close_finish ()
void | e_dbus_address_book_complete_close ()
gboolean | e_dbus_address_book_call_refresh_sync ()
void | e_dbus_address_book_call_refresh ()
gboolean | e_dbus_address_book_call_refresh_finish ()
void | e_dbus_address_book_complete_refresh ()
gboolean | e_dbus_address_book_call_create_contacts_sync ()
void | e_dbus_address_book_call_create_contacts ()
gboolean | e_dbus_address_book_call_create_contacts_finish ()
void | e_dbus_address_book_complete_create_contacts ()
gboolean | e_dbus_address_book_call_modify_contacts_sync ()
void | e_dbus_address_book_call_modify_contacts ()
gboolean | e_dbus_address_book_call_modify_contacts_finish ()
void | e_dbus_address_book_complete_modify_contacts ()
gboolean | e_dbus_address_book_call_remove_contacts_sync ()
void | e_dbus_address_book_call_remove_contacts ()
gboolean | e_dbus_address_book_call_remove_contacts_finish ()
void | e_dbus_address_book_complete_remove_contacts ()
gboolean | e_dbus_address_book_call_get_contact_sync ()
void | e_dbus_address_book_call_get_contact ()
gboolean | e_dbus_address_book_call_get_contact_finish ()
void | e_dbus_address_book_complete_get_contact ()
gboolean | e_dbus_address_book_call_get_contact_list_sync ()
void | e_dbus_address_book_call_get_contact_list ()
gboolean | e_dbus_address_book_call_get_contact_list_finish ()
void | e_dbus_address_book_complete_get_contact_list ()
gboolean | e_dbus_address_book_call_get_contact_list_uids_sync ()
void | e_dbus_address_book_call_get_contact_list_uids ()
gboolean | e_dbus_address_book_call_get_contact_list_uids_finish ()
void | e_dbus_address_book_complete_get_contact_list_uids ()
gboolean | e_dbus_address_book_call_get_view_sync ()
void | e_dbus_address_book_call_get_view ()
gboolean | e_dbus_address_book_call_get_view_finish ()
void | e_dbus_address_book_complete_get_view ()
gboolean | e_dbus_address_book_call_get_cursor_sync ()
void | e_dbus_address_book_call_get_cursor ()
gboolean | e_dbus_address_book_call_get_cursor_finish ()
void | e_dbus_address_book_complete_get_cursor ()
void | e_dbus_address_book_emit_error ()
GDBusInterfaceInfo * | e_dbus_address_book_interface_info ()
guint | e_dbus_address_book_override_properties ()
EDBusAddressBook * | e_dbus_address_book_proxy_new_sync ()
void | e_dbus_address_book_proxy_new ()
EDBusAddressBook * | e_dbus_address_book_proxy_new_finish ()
EDBusAddressBook * | e_dbus_address_book_proxy_new_for_bus_sync ()
void | e_dbus_address_book_proxy_new_for_bus ()
EDBusAddressBook * | e_dbus_address_book_proxy_new_for_bus_finish ()
EDBusAddressBook * | e_dbus_address_book_skeleton_new ()

## Properties

gchar * | cache-dir | Read / Write
GStrv | capabilities | Read / Write
gchar * | locale | Read / Write
gboolean | online | Read / Write
GStrv | required-fields | Read / Write
gchar * | revision | Read / Write
GStrv | supported-fields | Read / Write
gboolean | writable | Read / Write

## Signals

void | error | Run Last
gboolean | handle-close | Run Last
gboolean | handle-create-contacts | Run Last
gboolean | handle-get-contact | Run Last
gboolean | handle-get-contact-list | Run Last
gboolean | handle-get-contact-list-uids | Run Last
gboolean | handle-get-cursor | Run Last
gboolean | handle-get-view | Run Last
gboolean | handle-modify-contacts | Run Last
gboolean | handle-open | Run Last
gboolean | handle-refresh | Run Last
gboolean | handle-remove-contacts | Run Last
gboolean | handle-retrieve-properties | Run Last

## Types and Values

| EDBusAddressBook
struct | EDBusAddressBookProxy
struct | EDBusAddressBookSkeleton

## Object Hierarchy

        GInterface
        ╰── EDBusAddressBook
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── EDBusAddressBookSkeleton
        ╰── GDBusProxy
            ╰── EDBusAddressBookProxy

## Prerequisites

EDBusAddressBook requires GObject.

## Implemented Interfaces

EDBusAddressBookProxy implements GDBusInterface, GInitable, GAsyncInitable and EDBusAddressBook.

EDBusAddressBookSkeleton implements GDBusInterface and EDBusAddressBook.

## Known Implementations

EDBusAddressBook is implemented by EDBusAddressBookProxy and EDBusAddressBookSkeleton.

## Description

## Functions

### e_dbus_address_book_get_online ()

    gboolean
    e_dbus_address_book_get_online (EDBusAddressBook *object);

Gets the value of the "Online" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value.

Since: 3.8

### e_dbus_address_book_set_online ()

    void
    e_dbus_address_book_set_online (EDBusAddressBook *object,
                                    gboolean value);

Sets the "Online" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_revision ()

    const gchar *
    e_dbus_address_book_get_revision (EDBusAddressBook *object);

Gets the value of the "Revision" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_revision()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_revision ()

    gchar *
    e_dbus_address_book_dup_revision (EDBusAddressBook *object);

Gets a copy of the "Revision" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_revision ()

    void
    e_dbus_address_book_set_revision (EDBusAddressBook *object,
                                      const gchar *value);

Sets the "Revision" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_locale ()

    const gchar *
    e_dbus_address_book_get_locale (EDBusAddressBook *object);

Gets the value of the "Locale" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_locale()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_locale ()

    gchar *
    e_dbus_address_book_dup_locale (EDBusAddressBook *object);

Gets a copy of the "Locale" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_locale ()

    void
    e_dbus_address_book_set_locale (EDBusAddressBook *object,
                                    const gchar *value);

Sets the "Locale" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_writable ()

    gboolean
    e_dbus_address_book_get_writable (EDBusAddressBook *object);

Gets the value of the "Writable" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value.

Since: 3.8

### e_dbus_address_book_set_writable ()

    void
    e_dbus_address_book_set_writable (EDBusAddressBook *object,
                                      gboolean value);

Sets the "Writable" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_cache_dir ()

    const gchar *
    e_dbus_address_book_get_cache_dir (EDBusAddressBook *object);

Gets the value of the "CacheDir" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_cache_dir()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_cache_dir ()

    gchar *
    e_dbus_address_book_dup_cache_dir (EDBusAddressBook *object);

Gets a copy of the "CacheDir" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_cache_dir ()

    void
    e_dbus_address_book_set_cache_dir (EDBusAddressBook *object,
                                       const gchar *value);

Sets the "CacheDir" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_capabilities ()

    const gchar *const *
    e_dbus_address_book_get_capabilities (EDBusAddressBook *object);

Gets the value of the "Capabilities" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_capabilities()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_capabilities ()

    gchar **
    e_dbus_address_book_dup_capabilities (EDBusAddressBook *object);

Gets a copy of the "Capabilities" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_strfreev()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_capabilities ()

    void
    e_dbus_address_book_set_capabilities (EDBusAddressBook *object,
                                          const gchar *const *value);

Sets the "Capabilities" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_required_fields ()

    const gchar *const *
    e_dbus_address_book_get_required_fields
                                   (EDBusAddressBook *object);

Gets the value of the "RequiredFields" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_required_fields()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_required_fields ()

    gchar **
    e_dbus_address_book_dup_required_fields
                                   (EDBusAddressBook *object);

Gets a copy of the "RequiredFields" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_strfreev()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_required_fields ()

    void
    e_dbus_address_book_set_required_fields
                                   (EDBusAddressBook *object,
                                    const gchar *const *value);

Sets the "RequiredFields" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_get_supported_fields ()

    const gchar *const *
    e_dbus_address_book_get_supported_fields
                                   (EDBusAddressBook *object);

Gets the value of the "SupportedFields" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `e_dbus_address_book_dup_supported_fields()` if on another thread.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none]

Since: 3.8

### e_dbus_address_book_dup_supported_fields ()

    gchar **
    e_dbus_address_book_dup_supported_fields
                                   (EDBusAddressBook *object);

Gets a copy of the "SupportedFields" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_strfreev()`.

[transfer full]

Since: 3.8

### e_dbus_address_book_set_supported_fields ()

    void
    e_dbus_address_book_set_supported_fields
                                   (EDBusAddressBook *object,
                                    const gchar *const *value);

Sets the "SupportedFields" D-Bus property to `value` .

Since this D-Bus property is not writable, it is only meaningful to use this function on the service-side.

[skip]

#### Parameters

object | A EDBusAddressBook. |
value | The value to set. |

Since: 3.8

### e_dbus_address_book_call_open_sync ()

    gboolean
    e_dbus_address_book_call_open_sync (EDBusAddressBook *proxy,
                                        gchar ***out_properties,
                                        GCancellable *cancellable,
                                        GError **error);

Synchronously invokes the `Open()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_open()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_properties | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_open ()

    void
    e_dbus_address_book_call_open (EDBusAddressBook *proxy,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously invokes the `Open()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_open_finish()` to get the result of the operation.

See `e_dbus_address_book_call_open_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_open_finish ()

    gboolean
    e_dbus_address_book_call_open_finish (EDBusAddressBook *proxy,
                                          gchar ***out_properties,
                                          GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `e_dbus_address_book_call_open()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_properties | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_open()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_open ()

    void
    e_dbus_address_book_complete_open (EDBusAddressBook *object,
                                       GDBusMethodInvocation *invocation,
                                       const gchar *const *properties);

Helper function used in service implementations to finish handling invocations of the `Open()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
properties | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_close_sync ()

    gboolean
    e_dbus_address_book_call_close_sync (EDBusAddressBook *proxy,
                                         GCancellable *cancellable,
                                         GError **error);

Synchronously invokes the `Close()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_close()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_close ()

    void
    e_dbus_address_book_call_close (EDBusAddressBook *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `Close()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_close_finish()` to get the result of the operation.

See `e_dbus_address_book_call_close_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_close_finish ()

    gboolean
    e_dbus_address_book_call_close_finish (EDBusAddressBook *proxy,
                                           GAsyncResult *res,
                                           GError **error);

Finishes an operation started with `e_dbus_address_book_call_close()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_close()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_close ()

    void
    e_dbus_address_book_complete_close (EDBusAddressBook *object,
                                        GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `Close()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 3.8

### e_dbus_address_book_call_refresh_sync ()

    gboolean
    e_dbus_address_book_call_refresh_sync (EDBusAddressBook *proxy,
                                           GCancellable *cancellable,
                                           GError **error);

Synchronously invokes the `Refresh()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_refresh()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_refresh ()

    void
    e_dbus_address_book_call_refresh (EDBusAddressBook *proxy,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Asynchronously invokes the `Refresh()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_refresh_finish()` to get the result of the operation.

See `e_dbus_address_book_call_refresh_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_refresh_finish ()

    gboolean
    e_dbus_address_book_call_refresh_finish
                                   (EDBusAddressBook *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_refresh()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_refresh()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_refresh ()

    void
    e_dbus_address_book_complete_refresh (EDBusAddressBook *object,
                                          GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `Refresh()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 3.8

### e_dbus_address_book_call_create_contacts_sync ()

    gboolean
    e_dbus_address_book_call_create_contacts_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_vcards,
                                    gchar ***out_uids,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CreateContacts()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_create_contacts()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_vcards | Argument to pass with the method invocation. |
out_uids | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_create_contacts ()

    void
    e_dbus_address_book_call_create_contacts
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_vcards,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CreateContacts()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_create_contacts_finish()` to get the result of the operation.

See `e_dbus_address_book_call_create_contacts_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_vcards | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_create_contacts_finish ()

    gboolean
    e_dbus_address_book_call_create_contacts_finish
                                   (EDBusAddressBook *proxy,
                                    gchar ***out_uids,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_create_contacts()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_uids | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_create_contacts()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_create_contacts ()

    void
    e_dbus_address_book_complete_create_contacts
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *const *uids);

Helper function used in service implementations to finish handling invocations of the `CreateContacts()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
uids | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_modify_contacts_sync ()

    gboolean
    e_dbus_address_book_call_modify_contacts_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_vcards,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `ModifyContacts()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_modify_contacts()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_vcards | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_modify_contacts ()

    void
    e_dbus_address_book_call_modify_contacts
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_vcards,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `ModifyContacts()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_modify_contacts_finish()` to get the result of the operation.

See `e_dbus_address_book_call_modify_contacts_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_vcards | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_modify_contacts_finish ()

    gboolean
    e_dbus_address_book_call_modify_contacts_finish
                                   (EDBusAddressBook *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_modify_contacts()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_modify_contacts()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_modify_contacts ()

    void
    e_dbus_address_book_complete_modify_contacts
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `ModifyContacts()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 3.8

### e_dbus_address_book_call_remove_contacts_sync ()

    gboolean
    e_dbus_address_book_call_remove_contacts_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_uids,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `RemoveContacts()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_remove_contacts()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_uids | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_remove_contacts ()

    void
    e_dbus_address_book_call_remove_contacts
                                   (EDBusAddressBook *proxy,
                                    const gchar *const *arg_uids,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `RemoveContacts()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_remove_contacts_finish()` to get the result of the operation.

See `e_dbus_address_book_call_remove_contacts_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_uids | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_remove_contacts_finish ()

    gboolean
    e_dbus_address_book_call_remove_contacts_finish
                                   (EDBusAddressBook *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_remove_contacts()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_remove_contacts()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_remove_contacts ()

    void
    e_dbus_address_book_complete_remove_contacts
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation);

Helper function used in service implementations to finish handling invocations of the `RemoveContacts()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]

Since: 3.8

### e_dbus_address_book_call_get_contact_sync ()

    gboolean
    e_dbus_address_book_call_get_contact_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_uid,
                                    gchar **out_vcard,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetContact()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_get_contact()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_uid | Argument to pass with the method invocation. |
out_vcard | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_get_contact ()

    void
    e_dbus_address_book_call_get_contact (EDBusAddressBook *proxy,
                                          const gchar *arg_uid,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `GetContact()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_get_contact_finish()` to get the result of the operation.

See `e_dbus_address_book_call_get_contact_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_uid | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_get_contact_finish ()

    gboolean
    e_dbus_address_book_call_get_contact_finish
                                   (EDBusAddressBook *proxy,
                                    gchar **out_vcard,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_get_contact()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_vcard | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_get_contact()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_get_contact ()

    void
    e_dbus_address_book_complete_get_contact
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *vcard);

Helper function used in service implementations to finish handling invocations of the `GetContact()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
vcard | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_get_contact_list_sync ()

    gboolean
    e_dbus_address_book_call_get_contact_list_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    gchar ***out_vcards,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetContactList()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_get_contact_list()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
out_vcards | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_get_contact_list ()

    void
    e_dbus_address_book_call_get_contact_list
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `GetContactList()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_get_contact_list_finish()` to get the result of the operation.

See `e_dbus_address_book_call_get_contact_list_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_get_contact_list_finish ()

    gboolean
    e_dbus_address_book_call_get_contact_list_finish
                                   (EDBusAddressBook *proxy,
                                    gchar ***out_vcards,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_get_contact_list()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_vcards | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_get_contact_list()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_get_contact_list ()

    void
    e_dbus_address_book_complete_get_contact_list
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *const *vcards);

Helper function used in service implementations to finish handling invocations of the `GetContactList()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
vcards | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_get_contact_list_uids_sync ()

    gboolean
    e_dbus_address_book_call_get_contact_list_uids_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    gchar ***out_uids,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetContactListUids()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_get_contact_list_uids()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
out_uids | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_get_contact_list_uids ()

    void
    e_dbus_address_book_call_get_contact_list_uids
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `GetContactListUids()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_get_contact_list_uids_finish()` to get the result of the operation.

See `e_dbus_address_book_call_get_contact_list_uids_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_get_contact_list_uids_finish ()

    gboolean
    e_dbus_address_book_call_get_contact_list_uids_finish
                                   (EDBusAddressBook *proxy,
                                    gchar ***out_uids,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_get_contact_list_uids()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_uids | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_get_contact_list_uids()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_get_contact_list_uids ()

    void
    e_dbus_address_book_complete_get_contact_list_uids
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *const *uids);

Helper function used in service implementations to finish handling invocations of the `GetContactListUids()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
uids | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_get_view_sync ()

    gboolean
    e_dbus_address_book_call_get_view_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    gchar **out_object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetView()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_get_view()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
out_object_path | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_get_view ()

    void
    e_dbus_address_book_call_get_view (EDBusAddressBook *proxy,
                                       const gchar *arg_query,
                                       GCancellable *cancellable,
                                       GAsyncReadyCallback callback,
                                       gpointer user_data);

Asynchronously invokes the `GetView()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_get_view_finish()` to get the result of the operation.

See `e_dbus_address_book_call_get_view_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_get_view_finish ()

    gboolean
    e_dbus_address_book_call_get_view_finish
                                   (EDBusAddressBook *proxy,
                                    gchar **out_object_path,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_get_view()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_object_path | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_get_view()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_get_view ()

    void
    e_dbus_address_book_complete_get_view (EDBusAddressBook *object,
                                           GDBusMethodInvocation *invocation,
                                           const gchar *object_path);

Helper function used in service implementations to finish handling invocations of the `GetView()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
object_path | Parameter to return. |

Since: 3.8

### e_dbus_address_book_call_get_cursor_sync ()

    gboolean
    e_dbus_address_book_call_get_cursor_sync
                                   (EDBusAddressBook *proxy,
                                    const gchar *arg_query,
                                    const gchar *const *arg_sort_keys,
                                    const gchar *const *arg_sort_types,
                                    gchar **out_object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetCursor()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_address_book_call_get_cursor()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
arg_sort_keys | Argument to pass with the method invocation. |
arg_sort_types | Argument to pass with the method invocation. |
out_object_path | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_call_get_cursor ()

    void
    e_dbus_address_book_call_get_cursor (EDBusAddressBook *proxy,
                                         const gchar *arg_query,
                                         const gchar *const *arg_sort_keys,
                                         const gchar *const *arg_sort_types,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);

Asynchronously invokes the `GetCursor()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_call_get_cursor_finish()` to get the result of the operation.

See `e_dbus_address_book_call_get_cursor_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusAddressBookProxy. |
arg_query | Argument to pass with the method invocation. |
arg_sort_keys | Argument to pass with the method invocation. |
arg_sort_types | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_call_get_cursor_finish ()

    gboolean
    e_dbus_address_book_call_get_cursor_finish
                                   (EDBusAddressBook *proxy,
                                    gchar **out_object_path,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_call_get_cursor()`.

#### Parameters

proxy | A EDBusAddressBookProxy. |
out_object_path | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_call_get_cursor()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.8

### e_dbus_address_book_complete_get_cursor ()

    void
    e_dbus_address_book_complete_get_cursor
                                   (EDBusAddressBook *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *object_path);

Helper function used in service implementations to finish handling invocations of the `GetCursor()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. | [transfer full]
object_path | Parameter to return. |

Since: 3.8

### e_dbus_address_book_emit_error ()

    void
    e_dbus_address_book_emit_error (EDBusAddressBook *object,
                                    const gchar *arg_error_message);

Emits the "Error" D-Bus signal.

#### Parameters

object | A EDBusAddressBook. |
arg_error_message | Argument to pass with the signal. |

Since: 3.8

### e_dbus_address_book_interface_info ()

    GDBusInterfaceInfo *
    e_dbus_address_book_interface_info (void);

Gets a machine-readable description of the org.gnome.evolution.dataserver.AddressBook D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

Since: 3.8

### e_dbus_address_book_override_properties ()

    guint
    e_dbus_address_book_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the EDBusAddressBook interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject-derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

Since: 3.8

### e_dbus_address_book_proxy_new_sync ()

    EDBusAddressBook *
    e_dbus_address_book_proxy_new_sync (GDBusConnection *connection,
                                        GDBusProxyFlags flags,
                                        const gchar *name,
                                        const gchar *object_path,
                                        GCancellable *cancellable,
                                        GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.AddressBook. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `e_dbus_address_book_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusAddressBookProxy]

Since: 3.8

### e_dbus_address_book_proxy_new ()

    void
    e_dbus_address_book_proxy_new (GDBusConnection *connection,
                                   GDBusProxyFlags flags,
                                   const gchar *name,
                                   const gchar *object_path,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.AddressBook. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_proxy_new_finish()` to get the result of the operation.

See `e_dbus_address_book_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_proxy_new_finish ()

    EDBusAddressBook *
    e_dbus_address_book_proxy_new_finish (GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `e_dbus_address_book_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusAddressBookProxy]

Since: 3.8

### e_dbus_address_book_proxy_new_for_bus_sync ()

    EDBusAddressBook *
    e_dbus_address_book_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `e_dbus_address_book_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `e_dbus_address_book_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusAddressBookProxy]

Since: 3.8

### e_dbus_address_book_proxy_new_for_bus ()

    void
    e_dbus_address_book_proxy_new_for_bus (GBusType bus_type,
                                           GDBusProxyFlags flags,
                                           const gchar *name,
                                           const gchar *object_path,
                                           GCancellable *cancellable,
                                           GAsyncReadyCallback callback,
                                           gpointer user_data);

Like `e_dbus_address_book_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_address_book_proxy_new_for_bus_finish()` to get the result of the operation.

See `e_dbus_address_book_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 3.8

### e_dbus_address_book_proxy_new_for_bus_finish ()

    EDBusAddressBook *
    e_dbus_address_book_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_address_book_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_address_book_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusAddressBookProxy]

Since: 3.8

### e_dbus_address_book_skeleton_new ()

    EDBusAddressBook *
    e_dbus_address_book_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.gnome.evolution.dataserver.AddressBook.

#### Returns

The skeleton object.

[transfer full][type EDBusAddressBookSkeleton]

Since: 3.8

## Types and Values

### EDBusAddressBook

    typedef struct _EDBusAddressBook EDBusAddressBook;

Abstract interface type for the D-Bus interface org.gnome.evolution.dataserver.AddressBook.

Since: 3.8

### struct EDBusAddressBookProxy

    struct EDBusAddressBookProxy;

The EDBusAddressBookProxy structure contains only private data and should only be accessed using the provided API.

Since: 3.8

### struct EDBusAddressBookSkeleton

    struct EDBusAddressBookSkeleton;

The EDBusAddressBookSkeleton structure contains only private data and should only be accessed using the provided API.

Since: 3.8

## Property Details

### The `“cache-dir”` property

      “cache-dir”                gchar *

Represents the D-Bus property "CacheDir".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: NULL

Since: 3.8

### The `“capabilities”` property

      “capabilities”             GStrv

Represents the D-Bus property "Capabilities".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Since: 3.8

### The `“locale”` property

      “locale”                   gchar *

Represents the D-Bus property "Locale".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: NULL

Since: 3.8

### The `“online”` property

      “online”                   gboolean

Represents the D-Bus property "Online".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: FALSE

Since: 3.8

### The `“required-fields”` property

      “required-fields”          GStrv

Represents the D-Bus property "RequiredFields".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Since: 3.8

### The `“revision”` property

      “revision”                 gchar *

Represents the D-Bus property "Revision".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: NULL

Since: 3.8

### The `“supported-fields”` property

      “supported-fields”         GStrv

Represents the D-Bus property "SupportedFields".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Since: 3.8

### The `“writable”` property

      “writable”                 gboolean

Represents the D-Bus property "Writable".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Flags: Read / Write

Default value: FALSE

Since: 3.8

## Signal Details

### The `“error”` signal

    void
    user_function (EDBusAddressBook *object,
                   gchar            *arg_error_message,
                   gpointer          user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "Error" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A EDBusAddressBook. |
arg_error_message | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 3.8

### The `“handle-close”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Close()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_close()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-create-contacts”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   GStrv                  arg_vcards,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CreateContacts()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_create_contacts()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_vcards | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-get-contact”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_uid,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetContact()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_get_contact()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_uid | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-get-contact-list”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_query,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetContactList()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_get_contact_list()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_query | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-get-contact-list-uids”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_query,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetContactListUids()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_get_contact_list_uids()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_query | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-get-cursor”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_query,
                   GStrv                  arg_sort_keys,
                   GStrv                  arg_sort_types,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetCursor()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_get_cursor()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_query | Argument passed by remote caller. |
arg_sort_keys | Argument passed by remote caller. |
arg_sort_types | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-get-view”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_query,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetView()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_get_view()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_query | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-modify-contacts”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   GStrv                  arg_vcards,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `ModifyContacts()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_modify_contacts()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_vcards | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-open”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Open()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_open()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-refresh”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Refresh()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_refresh()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-remove-contacts”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   GStrv                  arg_uids,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `RemoveContacts()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_remove_contacts()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
arg_uids | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8

### The `“handle-retrieve-properties”` signal

    gboolean
    user_function (EDBusAddressBook      *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `RetrieveProperties()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_address_book_complete_retrieve_properties()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusAddressBook. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.8